program pexeso;
{$r pexeso.res}
uses
  wintypes, winprocs, owindows, odialogs, strings;
const
  cm_nova = 101;
  cm_konec = 102;
  cm_oprog = 103;
  cm_jak = 104;
type
  ppexwindow = ^tpexwindow;
  tpexwindow = object(twindow)
    pexeso, pozadi, listao, obr1, obr2, obr3, obr4, obr5,
      obr6, obr7, obr8, obr9, obr10, obr11, obr12, obr13,
      obr14, obr15, obr16, obr17, obr18: hbitmap;
    kursor: hcursor;
    hra, cekat, zacatek: boolean;
    soux, souy, kx, ky, k, otx, oty, ot, ulx, uly, ul, pam, dvoj: integer;
    pole: array[1..36] of integer;
    otoc: array[1..36] of boolean;
    constructor init(aparent: pwindowsobject; atitle: pchar);
    function canclose: boolean; virtual;
    procedure obraz(dc: hdc; x, y, bitmap: hbitmap);
    procedure getwindowclass(var wndclass: twndclass); virtual;
    procedure paint(obrdc: hdc; var paintinfo: tpaintstruct); virtual;
    procedure setupwindow; virtual;
    procedure wmlbuttondown(var msg: tmessage); virtual wm_lbuttondown;
    procedure wmrbuttondown(var msg: tmessage); virtual wm_rbuttondown;
    procedure plocha(dc: hdc);
    procedure rub(dc: hdc);
    procedure otocena(dc: hdc);
    procedure novahra;
    procedure vyber;
    procedure konec;
    procedure naprav;
    procedure cmnova(var msg: tmessage); virtual cm_first + cm_nova;
    procedure cmkonec(var msg: tmessage); virtual cm_first + cm_konec;
    procedure cmoprog(var msg: tmessage); virtual cm_first + cm_oprog;
    procedure cmjak(var msg: tmessage); virtual cm_first + cm_jak;
  end;
  tapp = object(tapplication)
    procedure initmainwindow; virtual;
  end;

constructor tpexwindow.init(aparent: pwindowsobject; atitle: pchar);
begin
  twindow.init(aparent, atitle);
  attr.w := 436;    {Dlka}
  attr.h := 474;    {Vka}
  attr.style := ws_caption or ws_sysmenu or ws_minimizebox;
  randomize;
end;

function tpexwindow.canclose: boolean;
begin
  canclose := true;
  if messagebox(hwindow, 'Opravdu chcete hru ukonit?', 'Pexeso', mb_YesNo or
  mb_IconQuestion) <> id_Yes then canclose := false;
end;

procedure tpexwindow.obraz(dc: hdc; x, y, bitmap: hbitmap);
var
  memdc : hdc;
  bm    : tbitmap;
  madedc: boolean;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  memdc := createcompatibledc(dc);
  selectobject(memdc, bitmap);
  getobject(pexeso, sizeof(bm), @bm);
  bitblt(dc, x, y, bm.bmwidth, bm.bmheight, memdc, 0, 0, srccopy);
  deletedc(memdc);
  if madedc then releasedc(hwindow, dc);
end;

procedure tpexwindow.getwindowclass(var wndclass: twndclass);
begin
  twindow.getwindowclass(wndclass);
  kursor := loadcursor(hinstance, 'KURSOR');
  wndclass.style := 0;
  wndclass.hcursor := kursor;
  wndclass.hicon := loadicon(hinstance, 'IKONA');
  wndclass.lpszmenuname := 'MENU';
end;

procedure tpexwindow.paint(obrdc: hdc; var paintinfo: tpaintstruct);
begin
  plocha(obrdc);
  if hra then
  begin
    rub(obrdc);
    otocena(obrdc);
  end;
  if zacatek then
  begin
    zacatek := false;
    messagebox(hwindow, 'Vtejte ve he Pexeso!', 'Pexeso', mb_Ok or mb_IconInformation);
  end;
end;

procedure tpexwindow.setupwindow;
var
  i: integer;
begin
  pexeso := loadbitmap(hinstance, 'PEXESO');
  pozadi := loadbitmap(hinstance, 'POZADI');
  listao := loadbitmap(hinstance, 'LISTAO');
  obr1 := loadbitmap(hinstance, 'OBR1');
  obr2 := loadbitmap(hinstance, 'OBR2');
  obr3 := loadbitmap(hinstance, 'OBR3');
  obr4 := loadbitmap(hinstance, 'OBR4');
  obr5 := loadbitmap(hinstance, 'OBR5');
  obr6 := loadbitmap(hinstance, 'OBR6');
  obr7 := loadbitmap(hinstance, 'OBR7');
  obr8 := loadbitmap(hinstance, 'OBR8');
  obr9 := loadbitmap(hinstance, 'OBR9');
  obr10 := loadbitmap(hinstance, 'OBR10');
  obr11 := loadbitmap(hinstance, 'OBR11');
  obr12 := loadbitmap(hinstance, 'OBR12');
  obr13 := loadbitmap(hinstance, 'OBR13');
  obr14 := loadbitmap(hinstance, 'OBR14');
  obr15 := loadbitmap(hinstance, 'OBR15');
  obr16 := loadbitmap(hinstance, 'OBR16');
  obr17 := loadbitmap(hinstance, 'OBR17');
  obr18 := loadbitmap(hinstance, 'OBR18');
  hra := true;
  cekat := false;
  zacatek := true;
  pam := 0;
  dvoj := 0;
  for i := 1 to 36 do otoc[i] := true;
  novahra;
end;

procedure tpexwindow.wmlbuttondown(var msg: tmessage);
begin
  if not cekat then
  begin
    soux := msg.lparamlo;
    souy := msg.lparamhi;
    vyber;
  end
  else
  begin
    cekat := false;
    pam := 0;
    rub(0);
  end;
end;

procedure tpexwindow.wmrbuttondown(var msg: tmessage);
begin
  if not cekat then
  begin
    soux := msg.lparamlo;
    souy := msg.lparamhi;
    vyber;
  end
  else
  begin
    cekat := false;
    pam := 0;
    rub(0);
  end;
end;

procedure tpexwindow.plocha(dc: hdc);
var
  i, j, px, py: integer;
begin
  py := 0;
  for i := 1 to 9 do
  begin
    px := 0;
    for j := 1 to 9 do
    begin
      obraz(dc, px, py, pozadi);
      px := px + 50;
    end;
    py := py + 50;
  end;
end;

procedure tpexwindow.rub(dc: hdc);
var
  rubx, ruby, rx, ry, r: integer;
begin
  plocha(dc);
  ry := 0; rx := 0; r := 0;
  for ruby := 1 to 6 do
  begin
    ry := ry + 2;
    rx := 0;
    for rubx := 1 to 6 do
    begin
      r := r + 1;
      rx := rx + 2;
      if otoc[r] then
      begin
        obraz(dc, rx, ry, pexeso);
      end;
      rx := rx + 70;
    end;
    ry := ry + 70;
  end;
end;

procedure tpexwindow.otocena(dc: hdc);
begin
  case pole[k] of
    1: obraz(dc, (kx-2), ky, obr1);
    2: obraz(dc, (kx-2), ky, obr2);
    3: obraz(dc, (kx-2), ky, obr3);
    4: obraz(dc, (kx-2), ky, obr4);
    5: obraz(dc, (kx-2), ky, obr5);
    6: obraz(dc, (kx-2), ky, obr6);
    7: obraz(dc, (kx-2), ky, obr7);
    8: obraz(dc, (kx-2), ky, obr8);
    9: obraz(dc, (kx-2), ky, obr9);
    10: obraz(dc, (kx-2), ky, obr10);
    11: obraz(dc, (kx-2), ky, obr11);
    12: obraz(dc, (kx-2), ky, obr12);
    13: obraz(dc, (kx-2), ky, obr13);
    14: obraz(dc, (kx-2), ky, obr14);
    15: obraz(dc, (kx-2), ky, obr15);
    16: obraz(dc, (kx-2), ky, obr16);
    17: obraz(dc, (kx-2), ky, obr17);
    18: obraz(dc, (kx-2), ky, obr18);
  end;
  if pam = 2 then
  begin
    case pole[ul] of
      1: obraz(dc, (ulx-2), uly, obr1);
      2: obraz(dc, (ulx-2), uly, obr2);
      3: obraz(dc, (ulx-2), uly, obr3);
      4: obraz(dc, (ulx-2), uly, obr4);
      5: obraz(dc, (ulx-2), uly, obr5);
      6: obraz(dc, (ulx-2), uly, obr6);
      7: obraz(dc, (ulx-2), uly, obr7);
      8: obraz(dc, (ulx-2), uly, obr8);
      9: obraz(dc, (ulx-2), uly, obr9);
      10: obraz(dc, (ulx-2), uly, obr10);
      11: obraz(dc, (ulx-2), uly, obr11);
      12: obraz(dc, (ulx-2), uly, obr12);
      13: obraz(dc, (ulx-2), uly, obr13);
      14: obraz(dc, (ulx-2), uly, obr14);
      15: obraz(dc, (ulx-2), uly, obr15);
      16: obraz(dc, (ulx-2), uly, obr16);
      17: obraz(dc, (ulx-2), uly, obr17);
      18: obraz(dc, (ulx-2), uly, obr18);
    end;
  end;
end;

procedure tpexwindow.novahra;
var
  i, j, nah: integer;
  hotovo   : boolean;
begin
  for i := 1 to 36 do pole[i] := 0;
  for i := 1 to 18 do
  begin
    for j := 1 to 2 do
    begin
      hotovo := false;
      repeat
        nah := random(36) + 1;
        if (nah < 1) or (nah > 36) then naprav;
        if pole[nah] = 0 then hotovo := true;
      until hotovo;
      pole[nah] := i;
    end;
  end;
  for i := 1 to 36 do otoc[i] := true;
  cekat := false;
  hra := true;
  rub(0);
  pam := 0;
  dvoj := 0;
end;

procedure tpexwindow.vyber;
var
  vybx, vyby: integer;
begin
  kx := 0; ky := 0; k := 0;
  for vyby := 1 to 6 do
  begin
    ky := ky + 2;
    kx := 2;
    for vybx := 1 to 6 do
    begin
      k := k + 1;
      kx := kx + 2;
      if (soux > kx) and (soux < kx + 71) then
      begin
        if (souy > ky) and (souy < ky + 71) then
        begin
          if not otoc[k] then exit;
          pam := pam + 1;
          if pam = 1 then
          begin
            ulx := kx;
            uly := ky;
            ul := k;
            otoc[ul] := false;
          end;
          if pam = 2 then
          begin
            cekat := true;
            otoc[k] := false;
            if pole[ul] = pole[k] then
            begin
              dvoj := dvoj + 1;
              otoc[k] := false;
              otoc[ul] := false;
            end
            else
            begin
              otoc[ul] := true;
              otoc[k] := true;
            end;
          end;
          otocena(0);
          if dvoj = 18 then konec;
        end;
      end;
      kx := kx + 70;
    end;
    ky := ky + 70;
  end;
end;

procedure tpexwindow.konec;
begin
  hra := false;
  if (messagebox(hwindow, 'Konec hry. Chcete hrt novou hru?', 'Pexeso', mb_YesNo or
    mb_IconQuestion)) = id_Yes then novahra
  else plocha(0);
end;

procedure tpexwindow.naprav;
begin
  messagebox(hwindow, 'Program zjistil, e udlal chybu, a proto ji naprav.', 'Pexeso',
    mb_Ok or mb_IconStop);
  novahra;
end;

procedure tpexwindow.cmnova(var msg: tmessage);
begin
  novahra;
end;

procedure tpexwindow.cmkonec(var msg: tmessage);
begin
  closewindow;
end;

procedure tpexwindow.cmoprog(var msg: tmessage);
begin
  application^.execdialog(new(pdialog, init(@self, 'OPROG')));
end;

procedure tpexwindow.cmjak(var msg: tmessage);
begin
  application^.execdialog(new(pdialog, init(@self, 'JAK')));
end;

procedure tapp.initmainwindow;
begin
  mainwindow := new(ppexwindow, init(nil, 'Pexeso'));
end;

procedure naplochu(var r: trect);
var
  bm: hbitmap;
  dc, memdc: hdc;
  bitinfo: tbitmap;
begin
  dc := getdc(0);
  memdc := createcompatibledc(dc);
  bm := loadbitmap(hinstance, 'PEXESO');
  getobject(bm, sizeof(bitinfo), @bitinfo);
  bm := selectobject(memdc, bm);
  r.left := getdevicecaps(dc,horzres) div 2 - bitinfo.bmwidth div 2;
  r.top := getdevicecaps(dc,vertres) div 2 - bitinfo.bmheight div 2;
  bitblt(dc, r.left, r.top, bitinfo.bmwidth, bitinfo.bmheight,
         memdc, 0, 0, srccopy);
  deleteobject(selectobject(memdc, bm));
  deletedc(memdc);
  releasedc(0, dc);
  r.right := r.left + bitinfo.bmwidth;
  r.bottom := r.top + bitinfo.bmheight;
end;

var
  app: tapp;
  r  : trect;
begin
  naplochu(r);
  app.init('PEXESO');
  invalidaterect(0, @r, true);
  app.run;
  app.done;
end.