program Prsi;
{$r prsi}
uses
  wintypes, winprocs, owindows, odialogs, wincrt, windos;
const
  cm_nova = 101;
  cm_jak = 102;
  cm_oprog = 103;
  cm_konec = 104;
type
  tkarta = record
             hodnota, barva: byte;
           end;

  tapp = object(tapplication)
    procedure initmainwindow; virtual;
  end;

  pprsiwindow = ^tprsiwindow;
  tprsiwindow = object(twindow)
    pozadi, uvod, a1, a2, a3, a4, a5, a6, a7, a8, b1, b2, b3, b4, b5, b6, b7, b8,
    c1, c2, c3, c4, c5, c6, c7, c8, d1, d2, d3, d4, d5, d6, d7, d8, rub, srdce, list,
    kule, zalud, prazdne, cs0, cs1, cs2, cs3, cs4, cs5, cs6, cs7, cs8, cs9, csp: hbitmap;
    hra, kdo, barvavyb                 : boolean;
    kursor                             : hcursor;
    bal, od, cl, poc                   : array[1..32] of tkarta;
    balpoc, odpoc, clpoc, pocpoc, barva: byte;
    constructor init(aparent: pwindowsobject; title: pchar);
    procedure drawBMP(dc: hdc; x, y, bitmap: hbitmap);
    procedure getwindowclass(var wndclass: twndclass); virtual;
    procedure paint(paintdc: hdc; var paintinfo: tpaintstruct); virtual;
    procedure setupwindow; virtual;
    procedure wmdestroy(var msg: tmessage); virtual wm_destroy;
    procedure kliknuto(x, y: word);
    procedure wmlbuttondown(var msg: tmessage); virtual wm_lbuttondown;
    procedure wmrbuttondown(var msg: tmessage); virtual wm_rbuttondown;
    procedure cmnova(var msg: tmessage); virtual cm_first + cm_nova;
    procedure cmjak(var msg: tmessage); virtual cm_first + cm_jak;
    procedure cmoprog(var msg: tmessage); virtual cm_first + cm_oprog;
    procedure cmkonec(var msg: tmessage); virtual cm_first + cm_konec;
    procedure stoji(kd: boolean);
    procedure lizej(kd, kolik: boolean);
    procedure posun(kd: boolean; c: byte);
    procedure comphraje;
    procedure konec;
    procedure drawbgrnd(dc: hdc);
    procedure drawintro(dc: hdc);
    procedure drawkarty(dc: hdc);
    function inside(x1, y1, x2, y2, x, y: integer): boolean;
  end;

constructor tprsiwindow.init(aparent: pwindowsobject; title: pchar);
begin
  twindow.init(aparent, title);
  attr.w := 600;
  attr.h := 420;
  attr.x := 20;
  attr.y := 20;
  attr.style := ws_caption or ws_sysmenu or ws_minimizebox;
  randomize;
end;

procedure tprsiwindow.drawBMP(dc: hdc; x, y, bitmap: hbitmap);
var
  memdc : hdc;
  bm    : tbitmap;
  madedc: boolean;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else madedc := false;
  memdc := createcompatibledc(dc);
  selectobject(memdc, bitmap);
  getobject(uvod, sizeof(bm), @bm);
  bitblt(dc, x, y, bm.bmwidth, bm.bmheight, memdc, 0, 0, srccopy);
  deletedc(memdc);
  if madedc then releasedc(hwindow, dc);
end;

procedure tprsiwindow.getwindowclass(var wndclass: twndclass);
begin
  twindow.getwindowclass(wndclass);
  kursor := loadcursor(hinstance, 'KURSOR');
  wndclass.style := 0;
  wndclass.hcursor := kursor;
  wndclass.hbrbackground := getstockobject(white_brush);
  wndclass.lpszmenuname := 'MENU';
  wndclass.hicon := loadicon(hinstance, 'IKONA');
end;

procedure tprsiwindow.paint(paintdc: hdc; var paintinfo: tpaintstruct);
begin
  drawbgrnd(paintdc);
  if not hra then drawintro(paintdc)
  else drawkarty(paintdc);
end;

procedure tprsiwindow.setupwindow;
begin
  pozadi := loadbitmap(hinstance, 'POZADI');
  uvod := loadbitmap(hinstance, 'UVOD');
  a1 := loadbitmap(hinstance, 'A1'); a2 := loadbitmap(hinstance, 'A2'); a3 := loadbitmap(hinstance, 'A3');
  a4 := loadbitmap(hinstance, 'A4'); a5 := loadbitmap(hinstance, 'A5'); a6 := loadbitmap(hinstance, 'A6');
  a7 := loadbitmap(hinstance, 'A7'); a8 := loadbitmap(hinstance, 'A8'); b1 := loadbitmap(hinstance, 'B1');
  b2 := loadbitmap(hinstance, 'B2'); b3 := loadbitmap(hinstance, 'B3'); b4 := loadbitmap(hinstance, 'B4');
  b5 := loadbitmap(hinstance, 'B5'); b6 := loadbitmap(hinstance, 'B6'); b7 := loadbitmap(hinstance, 'B7');
  b8 := loadbitmap(hinstance, 'B8'); c1 := loadbitmap(hinstance, 'C1'); c2 := loadbitmap(hinstance, 'C2');
  c3 := loadbitmap(hinstance, 'C3'); c4 := loadbitmap(hinstance, 'C4'); c5 := loadbitmap(hinstance, 'C5');
  c6 := loadbitmap(hinstance, 'C6'); c7 := loadbitmap(hinstance, 'C7'); c8 := loadbitmap(hinstance, 'C8');
  d1 := loadbitmap(hinstance, 'D1'); d2 := loadbitmap(hinstance, 'D2'); d3 := loadbitmap(hinstance, 'D3');
  d4 := loadbitmap(hinstance, 'D4'); d5 := loadbitmap(hinstance, 'D5'); d6 := loadbitmap(hinstance, 'D6');
  d7 := loadbitmap(hinstance, 'D7'); d8 := loadbitmap(hinstance, 'D8');
  rub := loadbitmap(hinstance, 'RUB');
  srdce := loadbitmap(hinstance, 'SRDCE');
  list := loadbitmap(hinstance, 'LIST');
  kule := loadbitmap(hinstance, 'KULE');
  zalud := loadbitmap(hinstance, 'ZALUD');
  prazdne := loadbitmap(hinstance, 'PRAZDNE');
  cs0 := loadbitmap(hinstance, 'CS0'); cs1 := loadbitmap(hinstance, 'CS1');
  cs2 := loadbitmap(hinstance, 'CS2'); cs3 := loadbitmap(hinstance, 'CS3');
  cs4 := loadbitmap(hinstance, 'CS4'); cs5 := loadbitmap(hinstance, 'CS5');
  cs6 := loadbitmap(hinstance, 'CS6'); cs7 := loadbitmap(hinstance, 'CS7');
  cs8 := loadbitmap(hinstance, 'CS8'); cs9 := loadbitmap(hinstance, 'CS9');
  csp := loadbitmap(hinstance, 'CSP');
  hra := false;
end;

procedure tprsiwindow.wmdestroy(var msg: tmessage);
begin
  deleteobject(pozadi);
  deleteobject(uvod);
  deleteobject(a1); deleteobject(a2); deleteobject(a3); deleteobject(a4); deleteobject(a5);
  deleteobject(a6); deleteobject(a7); deleteobject(a8); deleteobject(b1); deleteobject(b2);
  deleteobject(b3); deleteobject(b4); deleteobject(b5); deleteobject(b6); deleteobject(b7);
  deleteobject(b8); deleteobject(c1); deleteobject(c2); deleteobject(c3); deleteobject(c4);
  deleteobject(c5); deleteobject(c6); deleteobject(c7); deleteobject(c8); deleteobject(d1);
  deleteobject(d2); deleteobject(d3); deleteobject(d4); deleteobject(d5); deleteobject(d6);
  deleteobject(d7); deleteobject(d8);
  deleteobject(rub);
  deleteobject(srdce);
  deleteobject(list);
  deleteobject(kule);
  deleteobject(zalud);
  deleteobject(prazdne);
  deleteobject(cs0); deleteobject(cs1); deleteobject(cs2); deleteobject(cs3); deleteobject(cs4);
  deleteobject(cs5); deleteobject(cs6); deleteobject(cs7); deleteobject(cs8); deleteobject(cs9);
  deleteobject(csp);
  twindow.wmdestroy(msg);
end;

procedure tprsiwindow.kliknuto(x, y: word);
  procedure vyberbarvu;
  begin
    if inside(200, 20, 217, 36, x, y) then
    begin
      barva := 1;
      barvavyb := false;
      kdo := false;
    end;
    if inside(218, 20, 235, 36, x, y) then
    begin
      barva := 2;
      barvavyb := false;
      kdo := false;
    end;
    if inside(236, 20, 253, 36, x, y) then
    begin
      barva := 3;
      barvavyb := false;
      kdo := false;
    end;
    if inside(254, 20, 271, 36, x, y) then
    begin
      barva := 4;
      barvavyb := false;
      kdo := false;
    end;
  end;
var
  i         : byte;
  pomx, pomy: word;
begin
  if not hra then exit;
  if kdo then
  begin
    if barvavyb then vyberbarvu
    else
    begin
      if inside(50, 20, 114, 116, x, y) then lizej(true, false);
      pomx := 2;
      for i := 1 to clpoc do
      begin
        if i < 10 then pomy := 160 else pomy := 258;
        if i = 10 then pomx := 2;
        if inside(pomx, pomy, pomx+64, pomy+96, x, y) then
        begin
          if cl[i].hodnota = 6 then
          begin
            barvavyb := true;
            inc(odpoc);
            od[odpoc] := cl[i];
            posun(true, i);
            break;
          end;
          if ((cl[i].barva = od[odpoc].barva) or ((barva <> 0) and (cl[i].barva = barva)) or
            (cl[i].hodnota = od[odpoc].hodnota)) and (cl[i].hodnota <> 6) then
          begin
            if barva <> 0 then barva := 0;
            if cl[i].hodnota = 8 then
            begin
              inc(odpoc);
              od[odpoc] := cl[i];
              posun(true, i);
              stoji(false);
              break;
            end;
            if cl[i].hodnota = 1 then
            begin
              inc(odpoc);
              od[odpoc] := cl[i];
              posun(true, i);
              lizej(false, true);
              break;
            end;
            inc(odpoc);
            od[odpoc] := cl[i];
            posun(true, i);
            kdo := false;
            break;
          end;
        end;
        pomx := pomx + 66;
      end;
    end;
  end;
  drawkarty(0);
  if clpoc = 0 then konec;
  if not hra then exit;
  if not kdo then
    repeat
      comphraje;
      drawkarty(0);
      if pocpoc = 0 then konec;
      if not hra then exit;
    until kdo;
end;

procedure tprsiwindow.wmlbuttondown(var msg: tmessage);
begin
  kliknuto(msg.lparamlo, msg.lparamhi);
end;

procedure tprsiwindow.wmrbuttondown(var msg: tmessage);
begin
  kliknuto(msg.lparamlo, msg.lparamhi);
end;

procedure tprsiwindow.cmnova(var msg: tmessage);
var
  i, j    : byte;
  pom     : tkarta;
  zaplneno: array[1..8, 1..4] of byte;
begin
  kdo := true;
  hra := true;
  barvavyb := false;
  barva := 0;
  balpoc := 0;
  odpoc := 0;
  clpoc := 0;
  pocpoc := 0;
  for j := 1 to 4 do
    for i := 1 to 8 do zaplneno[i, j] := 0;
  repeat
    pom.hodnota := random(8) + 1;
    pom.barva := random(4) + 1;
    if zaplneno[pom.hodnota, pom.barva] = 0 then
    begin
      zaplneno[pom.hodnota, pom.barva] := 1;
      inc(balpoc);
      bal[balpoc].hodnota := pom.hodnota;
      bal[balpoc].barva := pom.barva;
    end;
  until (balpoc >= 32);
  for i := 1 to 4 do
  begin
    inc(clpoc); cl[clpoc] := bal[balpoc]; dec(balpoc);
    inc(pocpoc); poc[pocpoc] := bal[balpoc]; dec(balpoc);
  end;
  inc(odpoc); od[odpoc] := bal[balpoc]; dec(balpoc);
  drawintro(0);
  drawkarty(0);
  if od[odpoc].hodnota = 8 then
  begin
    stoji(true);
    repeat
      comphraje;
      drawkarty(0);
      if pocpoc = 0 then konec;
      if not hra then exit;
    until kdo;
  end;
  if od[odpoc].hodnota = 1 then
  begin
    lizej(true, true);
    repeat
      comphraje;
      drawkarty(0);
      if pocpoc = 0 then konec;
      if not hra then exit;
    until kdo;
  end;
end;

procedure tprsiwindow.cmjak(var msg: tmessage);
begin
  application^.execdialog(new(pdialog, init(@self, 'JAK')));
end;

procedure tprsiwindow.cmoprog(var msg: tmessage);
begin
  application^.execdialog(new(pdialog, init(@self, 'OPROG')));
end;

procedure tprsiwindow.cmkonec(var msg: tmessage);
begin
  closewindow;
end;

procedure tprsiwindow.stoji(kd: boolean);
begin
  if kd then
  begin
    kdo := false;
  end
  else
  begin
    kdo := true;
  end;
end;

procedure tprsiwindow.lizej(kd, kolik: boolean);
  procedure otocbal;
  var
    i: byte;
  begin
    for i := odpoc - 1 downto 1 do
    begin
      inc(balpoc);
      bal[balpoc] := od[i];
    end;
    od[1] := od[odpoc];
    odpoc := 1;
  end;
begin
  if (kolik and (balpoc < 3)) or (not kolik and (balpoc < 2)) then otocbal;
  if kd then
  begin
    if kolik then
    begin
      inc(clpoc);
      cl[clpoc] := bal[balpoc];
      dec(balpoc);
    end;
    inc(clpoc);
    cl[clpoc] := bal[balpoc];
    dec(balpoc);
    kdo := false;
  end
  else
  begin
    if kolik then
    begin
      inc(pocpoc);
      poc[pocpoc] := bal[balpoc];
      dec(balpoc);
    end;
    inc(pocpoc);
    poc[pocpoc] := bal[balpoc];
    dec(balpoc);
    kdo := true;
  end;
end;

procedure tprsiwindow.posun(kd: boolean; c: byte);
var
  z: byte;
begin
  if kd then
  begin
    for z := c to clpoc do
    begin
      if z <> clpoc then cl[z] := cl[z+1];
    end;
    dec(clpoc);
  end
  else
  begin
    for z := c to pocpoc do
    begin
      if z <> pocpoc then poc[z] := poc[z+1];
    end;
    dec(pocpoc);
  end;
end;

procedure tprsiwindow.comphraje;
  function masvrsky: boolean;
  var
    p: byte;
  begin
    masvrsky := false;
    for p := 1 to pocpoc do
      if poc[p].hodnota = 6 then masvrsky := true;
  end;
  function makarty: boolean;
  var
    p: byte;
  begin
    makarty := false;
    for p := 1 to pocpoc do
      if (((barva <> 0) and (barva = poc[p].barva)) or ((barva = 0) and
        ((poc[p].barva = od[odpoc].barva) or (poc[p].hodnota = od[odpoc].hodnota)))) then
        makarty := true;
  end;
  function maesa(b: byte): boolean;
  var
    p: byte;
  begin
    maesa := false;
    for p := 1 to pocpoc do
      if (poc[p].hodnota = 8) and (poc[p].barva = b) then maesa := true;
  end;
  function masedmy(b: byte): boolean;
  var
    p: byte;
  begin
    masedmy := false;
    for p := 1 to pocpoc do
      if (poc[p].hodnota = 1) and (poc[p].barva = b) then masedmy := true;
  end;
  function mabarvu(b: byte): boolean;
  var
    p: byte;
  begin
    mabarvu := false;
    for p := 1 to pocpoc do
      if poc[p].barva = b then mabarvu := true;
  end;
  procedure zmenbarvu;
  var
    f, g: byte;
  begin
    barva := 0;
    for f := 1 to 4 do
      if masedmy(f) or maesa(f) then
      begin
        barva := f;
        for g := 1 to pocpoc do
          if poc[g].hodnota = 6 then break;
        inc(odpoc);
        od[odpoc] := poc[g];
        posun(false, g);
        break;
      end;
    if barva = 0 then
      for f := 1 to pocpoc do
      begin
        barva := poc[f].barva;
        for g := 1 to pocpoc do
          if poc[g].hodnota = 6 then break;
        inc(odpoc);
        od[odpoc] := poc[g];
        posun(false, g);
        break;
      end;
    kdo := true;
  end;
var
  i, j, cas                 : byte;
  odehrano                  : boolean;
  hod, min, sec, ssec, nssec: word;
begin
  cas := 0;
  nssec := 0;
  repeat
    gettime(hod, min, sec, ssec);
    if ssec <> nssec then
    begin
      nssec := ssec;
      inc(cas);
    end;
  until (cas = 25);
  if makarty then
  begin
    odehrano := false;
    if (barva <> 0) and not odehrano then
      for i := 1 to pocpoc do
        if poc[i].barva = barva then
        begin
          kdo := true;
          if poc[i].hodnota = 1 then lizej(true, true);
          if poc[i].hodnota = 6 then zmenbarvu;
          if poc[i].hodnota = 8 then stoji(true);
          if poc[i].hodnota <> 6 then
          begin
            inc(odpoc);
            od[odpoc] := poc[i];
            barva := 0;
            posun(false, i);
          end;
          odehrano := true;
          break;
        end;
    if (barva = 0) and not odehrano then
      for i := 1 to pocpoc do
        if (poc[i].hodnota = od[odpoc].hodnota) or (poc[i].barva = od[odpoc].barva) then
        begin
          kdo := true;
          if poc[i].hodnota = 1 then lizej(true, true);
          if poc[i].hodnota = 6 then zmenbarvu;
          if poc[i].hodnota = 8 then stoji(true);
          if poc[i].hodnota <> 6 then
          begin
            inc(odpoc);
            od[odpoc] := poc[i];
            posun(false, i);
          end;
          odehrano := true;
          break;
        end;
  end
  else
    if masvrsky then zmenbarvu
    else lizej(false, false);
end;

procedure tprsiwindow.konec;
begin
  hra := false;
  drawbgrnd(0);
  drawintro(0);
  if clpoc = 0 then messagebox(hwindow, 'Blahopeji k vhe!', 'Pr', mb_ok or mb_iconinformation)
  else messagebox(hwindow, 'est poraenm!', 'Pr', mb_ok or mb_iconinformation);
end;

procedure tprsiwindow.drawbgrnd(dc: hdc);
var
  pomx, pomy: word;
  i, j      : byte;
begin
  pomy := 0;
  for j := 1 to 21 do
  begin
    pomx := 0;
    for i := 1 to 30 do
    begin
      drawBMP(dc, pomx, pomy, pozadi);
      pomx := pomx + 20;
    end;
    pomy := pomy + 20;
  end;
end;

procedure tprsiwindow.drawintro(dc: hdc);
begin
  if hra then drawbgrnd(dc)
  else drawBMP(dc, 140, 110, uvod);
end;

procedure tprsiwindow.drawkarty(dc: hdc);
  procedure nakresli(dc: hdc; x, y: word; obr: tkarta);
  begin
    if obr.barva = 1 then
      case obr.hodnota of
        1: drawBMP(dc, x, y, a1);
        2: drawBMP(dc, x, y, a2);
        3: drawBMP(dc, x, y, a3);
        4: drawBMP(dc, x, y, a4);
        5: drawBMP(dc, x, y, a5);
        6: drawBMP(dc, x, y, a6);
        7: drawBMP(dc, x, y, a7);
        8: drawBMP(dc, x, y, a8);
      end;
    if obr.barva = 2 then
      case obr.hodnota of
        1: drawBMP(dc, x, y, b1);
        2: drawBMP(dc, x, y, b2);
        3: drawBMP(dc, x, y, b3);
        4: drawBMP(dc, x, y, b4);
        5: drawBMP(dc, x, y, b5);
        6: drawBMP(dc, x, y, b6);
        7: drawBMP(dc, x, y, b7);
        8: drawBMP(dc, x, y, b8);
      end;
    if obr.barva = 3 then
      case obr.hodnota of
        1: drawBMP(dc, x, y, c1);
        2: drawBMP(dc, x, y, c2);
        3: drawBMP(dc, x, y, c3);
        4: drawBMP(dc, x, y, c4);
        5: drawBMP(dc, x, y, c5);
        6: drawBMP(dc, x, y, c6);
        7: drawBMP(dc, x, y, c7);
        8: drawBMP(dc, x, y, c8);
      end;
    if obr.barva = 4 then
      case obr.hodnota of
        1: drawBMP(dc, x, y, d1);
        2: drawBMP(dc, x, y, d2);
        3: drawBMP(dc, x, y, d3);
        4: drawBMP(dc, x, y, d4);
        5: drawBMP(dc, x, y, d5);
        6: drawBMP(dc, x, y, d6);
        7: drawBMP(dc, x, y, d7);
        8: drawBMP(dc, x, y, d8);
      end;
  end;
  procedure cislo(dc: hdc; x, y: word; c: byte);
  begin
    if (c > 9) and (c < 20) then
    begin
      c := c - 10;
      drawBMP(dc, x, y, cs1);
    end;
    if (c > 19) and (c < 30) then
    begin
      c := c - 20;
      drawBMP(dc, x, y, cs2);
    end;
    if (c > 29) and (c < 40) then
    begin
      c := c - 30;
      drawBMP(dc, x, y, cs3);
    end;
    case c of
      0: drawBMP(dc, x+16, y, cs0);
      1: drawBMP(dc, x+16, y, cs1);
      2: drawBMP(dc, x+16, y, cs2);
      3: drawBMP(dc, x+16, y, cs3);
      4: drawBMP(dc, x+16, y, cs4);
      5: drawBMP(dc, x+16, y, cs5);
      6: drawBMP(dc, x+16, y, cs6);
      7: drawBMP(dc, x+16, y, cs7);
      8: drawBMP(dc, x+16, y, cs8);
      9: drawBMP(dc, x+16, y, cs9);
    end;
  end;
var
  i         : byte;
  pomx, pomy: word;
begin
  pomx := 2;
  for i := 1 to clpoc + 1 do
  begin
    if i < 10 then pomy := 160 else pomy := 258;
    if i = 10 then pomx := 2;
    drawBMP(dc, pomx, pomy, prazdne);
    pomx := pomx + 66;
  end;
  pomx := 2;
  for i := 1 to clpoc do
  begin
    if i < 10 then pomy := 160 else pomy := 258;
    if i = 10 then pomx := 2;
    nakresli(dc, pomx, pomy, cl[i]);
    pomx := pomx + 66;
  end;
  {pomx := 2;                      (* Kontrola hry potae *)
  for i := 1 to pocpoc + 1 do
  begin
    if i < 10 then pomy := 0 else pomy := 98;
    if i = 10 then pomx := 2;
    drawBMP(dc, pomx, pomy, prazdne);
    pomx := pomx + 66;
  end;
  pomx := 2;
  for i := 1 to pocpoc do
  begin
    if i < 10 then pomy := 0 else pomy := 98;
    if i = 10 then pomx := 2;
    nakresli(dc, pomx, pomy, poc[i]);
    pomx := pomx + 66;
  end;}
  drawBMP(dc, 50, 20, rub);
  drawBMP(dc, 10, 20, csp);
  cislo(dc, 10, 20, balpoc);
  drawBMP(dc, 300, 20, csp);
  case barva of
    1: drawBMP(dc, 300, 20, srdce);
    2: drawBMP(dc, 300, 20, list);
    3: drawBMP(dc, 300, 20, kule);
    4: drawBMP(dc, 300, 20, zalud);
  end;
  drawBMP(dc, 200, 20, csp);
  drawBMP(dc, 232, 20, csp);
  drawBMP(dc, 264, 20, csp);
  if barvavyb then
  begin
    drawBMP(dc, 200, 20, srdce);
    drawBMP(dc, 218, 20, list);
    drawBMP(dc, 236, 20, kule);
    drawBMP(dc, 254, 20, zalud);
  end;
  nakresli(dc, 360, 20, od[odpoc]);
  drawBMP(dc, 474, 20, rub);
  drawBMP(dc, 556, 20, csp);
  cislo(dc, 556, 20, pocpoc);
end;

function tprsiwindow.inside(x1, y1, x2, y2, x, y: integer): boolean;
begin
  inside := (x >= x1) and (y >=y1) and (x <= x2) and (y <= y2);
end;

procedure tapp.initmainwindow;
begin
  mainwindow := new(pprsiwindow, init(nil, 'Pr'));
end;

var
  app: tapp;
begin
  app.init('Pr');
  app.run;
  app.done;
end.